#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "agi-namelookup.h"


/*
*    Converts compact to regular format
*
*    Author: R.J. van der Putten, Leiden, Holland, 
*    rob at sput dot nl.
* 
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License version 3 as
*    published by the Free Software Foundation.
* 
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*/


int main(int argc, char **argv)
{
    char numnam[256], idxnam[256], lstnam[256];
    struct phnum num;
    struct phidx idx;
    FILE *numfil, *idxfil, *lstfil;

    memset(numnam, 0, 256);
    memset(idxnam, 0, 256);
    memset(lstnam, 0, 256);
    numfil = NULL;
    idxfil = NULL;
    lstfil = NULL;
    memset(&num, 0, sizeof(num));
    memset(&idx, 0, sizeof(idx));

    if (argc != 2) {
	fprintf(stderr, "Specify file prefix\n");
	exit(1);
    }

    snprintf(numnam, 255, "%s.db", argv[1]);
    snprintf(idxnam, 255, "%s.idx", argv[1]);
    snprintf(lstnam, 255, "%s.lst", argv[1]);

    if ((idxfil = fopen(idxnam, "r")) == NULL) {
	fprintf(stderr, "Can't open %s\n", idxnam);
	exit(1);
    }

    if ((lstfil = fopen(lstnam, "r")) == NULL) {
	fprintf(stderr, "Can't open %s\n", lstnam);
	fclose(idxfil);
	exit(1);
    }
    if ((numfil = fopen(numnam, "w")) == NULL) {
	fprintf(stderr, "Can't open %s\n", numnam);
	fclose(lstfil);
	fclose(idxfil);
	exit(1);
    }

    while (fread(&idx, sizeof(idx), 1, idxfil)) {
	memset(&num, 0, sizeof(num));
	memcpy(num.num, idx.num, ANL_NUM_SIZ);
	num.len = idx.len;
	if (fseek(lstfil, (long) idx.offs, SEEK_SET) != 0) {
	    fprintf(stderr, "Error in index file %s\n", idxnam);
	    exit(1);
	}
	if (fread(num.name, 1, idx.namlen + 1, lstfil) != idx.namlen + 1) {
	    fprintf(stderr, "Error in index file %s\n", idxnam);
	    exit(1);
	}
	//printf("%s %d %s\n", num.num, num.len, num.name);
	fwrite(&num, sizeof(num), 1, numfil);
    }

    fclose(numfil);
    fclose(lstfil);
    fclose(idxfil);

    return(0);
}

